/*********************************************************************
 *
 *              BLINK LED on RA0 for PIC32MX120F032B
 *
 *********************************************************************
 * Qlɂ:        custom_ld_file.c
@*                    operate_in_idle.c
 ********************************************************************/
#include <p32xxxx.h>			// Required for SFR defs
#include <plib.h>				// I/O|[gpɒǉ

//
#pragma config FPLLMUL = MUL_20, FPLLIDIV = DIV_2, FPLLODIV = DIV_2, FWDTEN = OFF
#pragma config POSCMOD = OFF, FNOSC = FRCPLL, FPBDIV = DIV_2
#pragma config JTAGEN = OFF, FSOSCEN = OFF	// ꂪȂJTAG֘A̒[qASOSCI=RB4gȂ


#define SYS_FREQ (40000000L)
#define PB_FREQ  (20000000L)

// Let compile time pre-processor calculate the PR1 (period)
#define PB_DIV         		2
#define PRESCALE       		8
#define TOGGLES_PER_SEC		1000
#define T1_TICK       		(SYS_FREQ/PB_DIV/PRESCALE/TOGGLES_PER_SEC)

void HW_init(void)
{
	// DIGIT
	PORTClearBits(IOPORT_B,BIT_2 | BIT_3 );			PORTClearBits(IOPORT_A,BIT_2 | BIT_3 );
	PORTSetPinsDigitalOut(IOPORT_B,BIT_2 | BIT_3 ); PORTSetPinsDigitalOut(IOPORT_A,BIT_2 | BIT_3 );
	// SEGMENT
	PORTClearBits(IOPORT_B,BIT_4 | BIT_5 | BIT_6 | BIT_7 | BIT_8 | BIT_9 | BIT_10 | BIT_11 );
	PORTSetPinsDigitalOut(IOPORT_B,BIT_4 | BIT_5 | BIT_6 | BIT_7 | BIT_8 | BIT_9 | BIT_10 | BIT_11 ); 
}

#define SEG_A BIT_4
#define SEG_B BIT_5
#define SEG_C BIT_6
#define SEG_D BIT_7
#define SEG_E BIT_8
#define SEG_F BIT_9
#define SEG_G BIT_10
#define SEG_DP BIT_11

void SegmentOut(char d)
{
	volatile int i;
	const int segment_on[10]={
		SEG_A | SEG_B | SEG_C | SEG_D | SEG_E | SEG_F                  , // 0
		        SEG_B | SEG_C                                          , // 1
		SEG_A | SEG_B |         SEG_D | SEG_E |         SEG_G          , // 2
		SEG_A | SEG_B | SEG_C | SEG_D |                 SEG_G          , // 3
		        SEG_B | SEG_C |                 SEG_F | SEG_G          , // 4
		SEG_A |         SEG_C | SEG_D |         SEG_F | SEG_G          , // 5
		SEG_A |         SEG_C | SEG_D | SEG_E | SEG_F | SEG_G          , // 6
		SEG_A | SEG_B | SEG_C                                          , // 7
		SEG_A | SEG_B | SEG_C | SEG_D | SEG_E | SEG_F | SEG_G          , // 8
		SEG_A | SEG_B | SEG_C | SEG_D |         SEG_F | SEG_G          , // 9
	};
	const int segment_off=
		SEG_A | SEG_B | SEG_C | SEG_D | SEG_E | SEG_F | SEG_G          ; // ALL

	PORTClearBits(IOPORT_B,segment_off);	// ALL SEGMENT OFF
	PORTSetBits(IOPORT_B,segment_on[d & 0x0f]);	// SET SEGMENT
	if(d & 0x80){
		PORTSetBits(IOPORT_B,SEG_DP);
	} else {
		PORTClearBits(IOPORT_B,SEG_DP);
	}
}	

void DigitOut(char d)
{
	switch(d){
		case 4:		// 10^4
			PORTClearBits(IOPORT_B,BIT_2 | BIT_3 );	
			PORTClearBits(IOPORT_A,BIT_2 | BIT_3 );
			PORTSetBits(IOPORT_B,BIT_2);
			break;
		case 3:		// 10^2
			PORTClearBits(IOPORT_B,BIT_2 | BIT_3 );	
			PORTClearBits(IOPORT_A,BIT_2 | BIT_3 );
			PORTSetBits(IOPORT_B,BIT_3);
			break;
		case 2:		// 10^1
			PORTClearBits(IOPORT_B,BIT_2 | BIT_3 );	
			PORTClearBits(IOPORT_A,BIT_2 | BIT_3 );
			PORTSetBits(IOPORT_A,BIT_2);
			break;
		case 1:		// 10^0
			PORTClearBits(IOPORT_B,BIT_2 | BIT_3 );	
			PORTClearBits(IOPORT_A,BIT_2 | BIT_3 );
			PORTSetBits(IOPORT_A,BIT_3);
			break;
		default:
		case 0:
			PORTClearBits(IOPORT_B,BIT_2 | BIT_3 );	
			PORTClearBits(IOPORT_A,BIT_2 | BIT_3 );
			break;
	}
}

unsigned char DisplayTable[4]={0,0,0,0};	// 0 = 10^0 , 1=10^1 , 2=10^2
										// bit7 = DP

void SetDisplay(int n)
{
	int i;
	int a,b;
	a=n;
	for(i=0;i<4;i++){
		b=a%10;
		DisplayTable[i]=b;
		a=a/10;
	}
}

void UpdateDisplay(void)
{
	static unsigned char d=0;
	DigitOut(0);
	SegmentOut(DisplayTable[d]);
	DigitOut(d+1);
	d++;
	if(d>3)d=0;
}

int main(void)
{
	// Configure the System
//    SYSTEMConfig(SYS_FREQ, SYS_CFG_WAIT_STATES | SYS_CFG_PCACHE);
	// set Timer1
    OpenTimer1(T1_ON | T1_SOURCE_INT | T1_PS_1_8 | T1_IDLE_CON, T1_TICK);
    // set up the timer interrupt with a priority of 2
    ConfigIntTimer1(T1_INT_ON | T1_INT_PRIOR_2);
    // enable multi-vector interrupts
    INTEnableSystemMultiVectoredInt();

//    mPORTAClearBits(BIT_7 | BIT_6 | BIT_5 | BIT_5 | BIT_4 | BIT_3 | BIT_2 | BIT_1 | BIT_0);
    mPORTAClearBits(BIT_0);

//    mPORTASetPinsDigitalOut(BIT_7 | BIT_6 | BIT_5 | BIT_5 | BIT_4 | BIT_3 | BIT_2 | BIT_1 | BIT_0);
    mPORTASetPinsDigitalOut(BIT_0);

	HW_init();

	while(1){
		// SetDisplay(tmp);
	}

	return 0;
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Timer 1 interrupt handler

unsigned int CountMS=0;
unsigned int CountSEC=0;
unsigned int DownCountMS=1;

void __ISR(_TIMER_1_VECTOR, ipl2) Timer1Handler(void) {
    // clear the interrupt flag
    mT1ClearIntFlag();

	CountMS++;
	SetDisplay(CountMS/100);
	DisplayTable[1] |= 0x80;	// Set DP
	UpdateDisplay();

	DownCountMS--;
	if(	DownCountMS == 0 ){
		DownCountMS = 1000;
		CountSEC++;
	    // toggle the LED
	    mPORTAToggleBits(BIT_0);
	}
}



